<!-- ********************************************************************************
 * Copyright (c) 2015, 2023 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 ******************************************************************************** -->

<style>
  :host ::ng-deep .p-tree .p-tree-container {
    margin: 0 0 4px 0 !important;
    width: 100%;
    overflow: visible;
  }

  :host ::ng-deep .p-tree .p-treenode .p-treenode-content .p-treenode-label {
    padding-right: 0.75em;
  }
</style>

<p-dialog
  [header]="'search.edit-searchfields.title-search-field-editor' | translate"
  [(visible)]="lgEditSearchFieldsModal"
  [breakpoints]="{ '960px': '75vw', '640px': '100vw' }"
  [style]="{ width: '60vw' }"
>
  <div class="flex gap-2">
    <div class="flex flex-column gap-2">
      <p-autoComplete
        #autocomplete
        [(ngModel)]="selectedSuggestion"
        [suggestions]="filteredSuggestions"
        field="label"
        (completeMethod)="search($event)"
        (onSelect)="onSelect($event)"
        [title]="'search.edit-searchfields.tooltip-no-wildcards' | translate"
        [placeholder]="'search.edit-searchfields.enter-search-text' | translate"
        styleClass="mb-2"
        appendTo="body"
      >
      </p-autoComplete>
      <mdm-searchattribute-tree
        [searchAttributes]="searchAttributes"
        [environments]="environments"
        style="max-height: 100%"
      ></mdm-searchattribute-tree>
    </div>
    <div style="flex-grow: 1">
      <label for="search-source" class="col-form-label" style="padding: 8px 0 15px 0">{{
        "search.edit-searchfields.lbl-selected-search-attributes" | translate
      }}</label>
      <div *ngIf="layout.getSourceNames().length === 0" style="text-align: center; width: 100%">
        {{ "search.edit-searchfields.no-search-attributes-selected" | translate }}
      </div>
      <div *ngFor="let env of layout.getSourceNames()">
        <div *ngIf="layout.getConditions(env).length > 0">
          <span style="font-weight: bold">{{ mapSourceNameToName(env) }}</span>
          <table class="table table-bordered searchdefinition">
            <colgroup>
              <col style="width: 44%" />
              <col style="width: 44%" />
              <col style="width: 4%" />
              <col style="width: 4%" />
              <col style="width: 4%" />
            </colgroup>
            <tr *ngFor="let condition of layout.getConditions(env)">
              <td>{{ condition?.type | mdmTranslate : env?.sourceName | async }}</td>
              <td>{{ condition?.type | mdmTranslate : env?.sourceName : condition?.attribute | async }}</td>
              <td style="width: 30px; text-align: center; vertical-align: middle">
                <span
                  class="fa fa-chevron-up"
                  [ngStyle]="{ visibility: isFirst(condition) ? 'hidden' : 'visible' }"
                  style="cursor: pointer; margin-bottom: 0"
                  (click)="moveUp(condition)"
                ></span>
              </td>
              <td style="width: 30px; text-align: center; vertical-align: middle">
                <span
                  class="fa fa-chevron-down"
                  [ngStyle]="{ visibility: isLast(condition) ? 'hidden' : 'visible' }"
                  style="cursor: pointer"
                  (click)="moveDown(condition)"
                ></span>
              </td>
              <td style="text-align: center">
                <span
                  class="pi pi-times"
                  style="cursor: pointer"
                  title="{{ 'search.edit-searchfields.remove' | translate }}"
                  (click)="removeCondition(condition)"
                ></span>
              </td>
            </tr>
          </table>
        </div>
      </div>
    </div>
  </div>

  <p-footer>
    <div class="flex gap-2 align-items-center justify-content-end">
      <p-button
        *ngIf="!newSearchFieldsComponent"
        icon="pi pi-check"
        (onClick)="addSearchFields()"
        [disabled]="conditions.length === 0"
        [label]="'search.edit-searchfields.btn-apply-changes' | translate"
      ></p-button>
      <p-dropdown
        *ngIf="newSearchFieldsComponent && conditions.length > 0"
        [options]="filters"
        [editable]="true"
        (onChange)="onChange($event)"
        optionLabel="name"
        optionValue="name"
        placeholder="Filter name"
        appendTo="body"
      ></p-dropdown>
      <p-button
        *ngIf="newSearchFieldsComponent"
        icon="pi pi-save"
        (onClick)="saveNewFilter($event)"
        [disabled]="!selectedFilterName || conditions.length === 0"
        [label]="'search.mdm-search.btn-save' | translate"
        [title]="'search.mdm-search.tooltip-save-search-filter' | translate"
      ></p-button>
    </div>
  </p-footer>
</p-dialog>
